import { useRef, useState, useEffect } from 'react';
var theme = 'snow';
var modules = {
    toolbar: [
        ['bold', 'italic', 'underline', 'strike'],
        [{ align: [] }],
        [{ list: 'ordered' }, { list: 'bullet' }],
        [{ indent: '-1' }, { indent: '+1' }],
        [{ size: ['small', false, 'large', 'huge'] }],
        [{ header: [1, 2, 3, 4, 5, 6, false] }],
        ['link', 'image', 'video'],
        [{ color: [] }, { background: [] }],
        ['clean'],
    ],
    clipboard: {
        matchVisual: false,
    },
};
var formats = [
    'bold', 'italic', 'underline', 'strike', 'align', 'list', 'indent',
    'size', 'header', 'link', 'image', 'video', 'color', 'background', 'clean'
];
export var useQuill = function (options) {
    if (options === void 0) { options = { theme: theme, modules: modules, formats: formats }; }
    if (!options) {
        options = {};
    }
    if (!options.modules) {
        options.modules = modules;
    }
    if (!options.formats) {
        options.formats = formats;
    }
    if (!options.theme) {
        options.theme = theme;
    }
    var editorRef = useRef();
    var _a = useState(), editor = _a[0], setEditor = _a[1];
    var Quill;
    useEffect(function () {
        if (!Quill) {
            Quill = require('quill');
        }
        if (!editor && editorRef && editorRef.current) {
            setEditor(new Quill(editorRef.current, options));
        }
    }, []);
    return {
        editorRef: editorRef,
        editor: editor,
    };
};
